// test.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
#include <conio.h>
#include <stdio.h>
#include <math.h>
#include <stdlib.h>
#include <string.h>

void calc(double *a, double *b, double *c, double *s, double *x, int n)
{
  double *k = new double[n];
  double *p = new double[n];
  double r;
  int i;
  k[1] = - c[1] / b[1];
   p[1] = s[1] / b[1];
   for (i = 2; i<=n; i++)
   {
      r = a[i] * k[i-1] + b[i];
      k[i] = - c[i] / r;
      p[i] = (s[i] - a[i] * p[i-1]) / r;
   }
   x[n] = p[n];
   for (i = n-1; i>=1; i--)
   {
      x[i] = k[i] * x[i+1] + p[i];
   }

}

void main(int argc, char* argv[])
{
   const n=4;
   double *a = new double[n];
   double *b = new double[n];
   double *c = new double[n];
   double *s = new double[n];
   double *x = new double[n];
   FILE *f = new FILE;
   int i;
   //clrscr();

   char *fnam="matrix1.txt";
   char *t = new char[20];
   char *d = new char[4];

   f=fopen (fnam, "rt");
   if (f==NULL)
   {
      printf("File with name %s is not exist \n", fnam);
      return;
  }
   i = 1;
   while(!feof(f))
   {
      fgets(t, 20, f);
      d = strtok(t, " ");
      a[i] = atof(d);
      d = strtok(NULL, " ");
      b[i] = atof(d);
      d = strtok(NULL, " ");
      c[i] = atof(d);
      d = strtok(NULL, " ");
      s[i] = atof(d);
      i++;
   }
   fclose(f);

   calc(a, b, c, s, x, n);

   printf("Coefficients of source linear system:\n\n");
   for(i=1; i<=n; i++)
   {
      printf("%10f %10f %10f %10f\n", a[i], b[i], c[i], s[i]);
   }
   printf("\nResult:\n\n");
   for(i=1; i<=n; i++)
   {
      printf("X%d = %f\n", i, x[i]);
   }
   return;
}
