// (c)2002 SkyJet's definition software :)))
// Kono puroguramu wa totemo tayasui da ne ^_~?

#include "stdafx.h"
#include <conio.h>
#include <stdio.h>
#include <math.h>
#include <stdlib.h>
#include <string.h>

double f(double x, double y)
{
	return x*exp(y); //Here you can insert your function like dy/dx = f(x,y);
}

void rgkt(double *xm, double *ym, double a, double b, double y0, double dy0, int n)
{
	double x = a, y = y0, h = (b - a)/n;
	double q1, q2, q3, q4;
	ym[0] = y0;
	for(int i = 0; i < n; i++)
	{
		q1 = f(x,y);
		q2 = f(x + h/2,y + h*q1/2);
		q3 = f(x + h/2,y + h*q2/2);
		q4 = f(x + h/2,y + h*q3);
		ym[i+1] = ym[i] + h*(q1 + 2*q2 + 2*q3 + q4)/6;
		xm[i] = x;
		x += h;
	}
}

double max(double *y, int n)
{
	double max = -10*exp(10);
	for(int i=0; i<n; i++)
	{
		if(y[i] > max) max = y[i];
	}
	return max;
}

int main(int argc, char* argv[])
{
	int n = 10; //Number of steps
	double a = 0, b = 1; //Solving area
	double y0 = 0, dy0 = 3.56; //Initial values (this ones have no use in this programm)
	double *x = new double[n];
    double *y = new double[n];
	double *x1 = new double[n];
    double *y1 = new double[n];
	
	rgkt(x, y, a, b, y0,dy0,n);
	rgkt(x1, y1, a, b, y0,dy0,n*2);
	double delta = fabs(max(y, n) - max(y1,n*2))/15;

	printf("%10s  %10s\n", "x   ", "f(x)  ");
	for(int i=0; i<n; i++)
	{
		printf("%10f  %10f\n", x[i], y[i]);
	}
	printf("\n  Absolute inaccuracy is equal: %f\n\n", delta);
	return 0;
}

